"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ImmutableXClient = void 0;
var imx_link_crypto_1 = require("@imtbl/imx-link-crypto");
var imx_link_types_1 = require("@imtbl/imx-link-types");
var utils_1 = require("../../../libs/utils");
var assert_1 = __importDefault(require("assert"));
var auto_bind_1 = __importDefault(require("auto-bind"));
var axios_1 = __importDefault(require("axios"));
var Either_1 = require("fp-ts/lib/Either");
var E = __importStar(require("fp-ts/lib/Either"));
var pipeable_1 = require("fp-ts/lib/pipeable");
var TE = __importStar(require("fp-ts/lib/TaskEither"));
var https = __importStar(require("https"));
var io_ts_reporters_1 = __importDefault(require("io-ts-reporters"));
var query_string_1 = __importDefault(require("query-string"));
/**
 * Immutable X REST API Client
 */
var ImmutableXClient = /** @class */ (function () {
    function ImmutableXClient(version, hostname, wallet) {
        if (version === void 0) { version = 'v0'; }
        this.version = version;
        this.hostname = hostname;
        this.wallet = wallet;
        axios_1.default.defaults.baseURL = this.hostname;
        this.agent = new https.Agent();
        assert_1.default(this.version.charAt(0) === 'v');
        this.version = '/' + this.version;
        auto_bind_1.default(this);
    }
    ImmutableXClient.prototype.buildOptions = function () {
        return {
            httpsAgent: this.agent,
            headers: {
                'Content-Type': 'application/json',
            },
        };
    };
    ImmutableXClient.prototype.get = function (path, decode) {
        var _this = this;
        return pipeable_1.pipe(TE.tryCatch(function () { return axios_1.default.get(_this.version + "/" + path, _this.buildOptions()); }, E.toError), TE.chain(function (r) { return pipeable_1.pipe(decode(r.data), E.mapLeft(utils_1.errorsToError), TE.fromEither); }));
    };
    ImmutableXClient.prototype.post = function (path, data, decode) {
        var _this = this;
        return pipeable_1.pipe(TE.tryCatch(function () { return axios_1.default.post(_this.version + "/" + path, data, _this.buildOptions()); }, E.toError), TE.chain(function (r) { return pipeable_1.pipe(decode(r.data), E.mapLeft(utils_1.errorsToError), TE.fromEither); }));
    };
    ImmutableXClient.prototype.registerF = function (_a) {
        var _this = this;
        var etherKey = _a.etherKey, starkPublicKey = _a.starkPublicKey;
        var nonce = 0;
        var body = {
            ether_key: etherKey,
            stark_key: starkPublicKey,
            nonce: nonce,
        };
        return pipeable_1.pipe(TE.tryCatch(function () { return _this.wallet.controller.signUserRegistration(etherKey, starkPublicKey, String(nonce)); }, E.toError), TE.chain(function (signature) {
            var data = JSON.stringify(__assign(__assign({}, body), { stark_signature: signature }));
            return _this.post('users', data, function (x) { return E.right(x); });
        }));
    };
    ImmutableXClient.prototype.register = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.decodeForFunction(params, imx_link_types_1.ImmutableMethodParams.ImmutableRegisterParamsCodec.decode, this.registerF)];
            });
        });
    };
    ImmutableXClient.prototype.depositF = function (_a) {
        var _this = this;
        var token = _a.token, starkPublicKey = _a.starkPublicKey, quantizedAmount = _a.quantizedAmount, vaultId = _a.vaultId, nonce = _a.nonce;
        var assetID = imx_link_crypto_1.getAssetID(token).val;
        var body = {
            stark_key: starkPublicKey,
            amount: parseInt(quantizedAmount),
            asset_id: assetID,
            vault_id: parseInt(vaultId),
            nonce: parseInt(nonce),
        };
        return pipeable_1.pipe(TE.tryCatch(function () { return _this.wallet.controller.signDeposit(starkPublicKey, vaultId, token, quantizedAmount, nonce); }, E.toError), TE.chain(function (signature) {
            var data = JSON.stringify(__assign(__assign({}, body), { stark_signature: signature }));
            return _this.post('tmp-deposits', data, imx_link_types_1.ImmutableMethodResults.ImmutableDepositResultCodec.decode);
        }));
    };
    ImmutableXClient.prototype.deposit = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.decodeForFunction(params, imx_link_types_1.ImmutableMethodParams.ImmutableDepositParamsCodec.decode, this.depositF)];
            });
        });
    };
    ImmutableXClient.prototype.getSignableDepositF = function (_a) {
        var etherKey = _a.etherKey, token = _a.token, quantizedAmount = _a.quantizedAmount;
        var data = JSON.stringify({
            ether_key: etherKey,
            token: {
                type: token.type,
                data: this.getTokenBody(token),
            },
            amount: parseInt(quantizedAmount),
        });
        return this.post('signable-deposit-details', data, imx_link_types_1.ImmutableMethodResults.ImmutableGetSignableDepositResultCodec.decode);
    };
    ImmutableXClient.prototype.getSignableDeposit = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.decodeForFunction(params, imx_link_types_1.ImmutableMethodParams.ImmutableGetSignableDepositParamsCodec.decode, this.getSignableDepositF)];
            });
        });
    };
    ImmutableXClient.prototype.depositCancel = function (starkPublicKey, token, vaultId) {
        return __awaiter(this, void 0, void 0, function () {
            var assetID, nonce, _a, body, signature, data, res, err_1;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        assetID = imx_link_crypto_1.getAssetID(token).val;
                        _a = parseInt;
                        return [4 /*yield*/, this.getLastAvailableNonce(starkPublicKey)];
                    case 1:
                        nonce = _a.apply(void 0, [(_b.sent()).Nonce]);
                        body = {
                            stark_key: starkPublicKey,
                            asset_id: assetID,
                            vault_id: parseInt(vaultId),
                            nonce: nonce,
                        };
                        return [4 /*yield*/, this.wallet.controller.signStark(body)];
                    case 2:
                        signature = _b.sent();
                        data = JSON.stringify(__assign(__assign({}, body), { stark_signature: signature }));
                        _b.label = 3;
                    case 3:
                        _b.trys.push([3, 5, , 6]);
                        return [4 /*yield*/, axios_1.default.post(this.version + '/cancel-deposit', data, this.buildOptions())];
                    case 4:
                        res = _b.sent();
                        return [2 /*return*/, res.data];
                    case 5:
                        err_1 = _b.sent();
                        throw utils_1.formatError(err_1);
                    case 6: return [2 /*return*/];
                }
            });
        });
    };
    ImmutableXClient.prototype.depositReclaim = function (starkPublicKey, token, vaultId) {
        return __awaiter(this, void 0, void 0, function () {
            var assetID, nonce, _a, body, signature, data, res, err_2;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        assetID = imx_link_crypto_1.getAssetID(token).val;
                        _a = parseInt;
                        return [4 /*yield*/, this.getLastAvailableNonce(starkPublicKey)];
                    case 1:
                        nonce = _a.apply(void 0, [(_b.sent()).Nonce]);
                        body = {
                            stark_key: starkPublicKey,
                            asset_id: assetID,
                            vault_id: parseInt(vaultId),
                            nonce: nonce,
                        };
                        return [4 /*yield*/, this.wallet.controller.signStark(body)];
                    case 2:
                        signature = _b.sent();
                        data = JSON.stringify(__assign(__assign({}, body), { stark_signature: signature }));
                        _b.label = 3;
                    case 3:
                        _b.trys.push([3, 5, , 6]);
                        return [4 /*yield*/, axios_1.default.post(this.version + '/reclaim-deposit', data, this.buildOptions())];
                    case 4:
                        res = _b.sent();
                        return [2 /*return*/, res.data];
                    case 5:
                        err_2 = _b.sent();
                        throw utils_1.formatError(err_2);
                    case 6: return [2 /*return*/];
                }
            });
        });
    };
    ImmutableXClient.prototype.withdrawal = function (starkPublicKey, quantizedAmount, token, vaultId, nonce) {
        return __awaiter(this, void 0, void 0, function () {
            var assetID, body, signature, data, res, result, err_3;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        assetID = imx_link_crypto_1.getAssetID(token).val;
                        body = {
                            stark_key: starkPublicKey,
                            amount: parseInt(quantizedAmount),
                            asset_id: assetID,
                            vault_id: parseInt(vaultId),
                            nonce: parseInt(nonce),
                        };
                        return [4 /*yield*/, this.wallet.controller.signWithdraw(starkPublicKey, vaultId, token, quantizedAmount, nonce)];
                    case 1:
                        signature = _a.sent();
                        data = JSON.stringify(__assign(__assign({}, body), { stark_signature: signature }));
                        _a.label = 2;
                    case 2:
                        _a.trys.push([2, 4, , 5]);
                        return [4 /*yield*/, axios_1.default.post(this.version + '/withdrawals', data, this.buildOptions())];
                    case 3:
                        res = _a.sent();
                        result = imx_link_types_1.ImmutableMethodResults.ImmutableWithdrawalResultCodec.decode(res.data);
                        if (Either_1.isRight(result)) {
                            return [2 /*return*/, result.right];
                        }
                        else {
                            console.error(utils_1.errorsToArray(result.left));
                            throw new Error('Problem decoding withdrawals result');
                        }
                        return [3 /*break*/, 5];
                    case 4:
                        err_3 = _a.sent();
                        throw utils_1.formatError(err_3);
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    ImmutableXClient.prototype.getSignableWithdrawal = function (etherKey, token, quantizedAmount) {
        return __awaiter(this, void 0, void 0, function () {
            var data, res, result, err_4;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        data = JSON.stringify({
                            sender: etherKey,
                            token: {
                                type: token.type,
                                data: this.getTokenBody(token),
                            },
                            amount: parseInt(quantizedAmount),
                        });
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, axios_1.default.post(this.version + '/signable-withdrawal-details', data, this.buildOptions())];
                    case 2:
                        res = _a.sent();
                        result = imx_link_types_1.ImmutableMethodResults.ImmutableGetSignableWithdrawalResultCodec.decode(res.data);
                        if (Either_1.isRight(result)) {
                            return [2 /*return*/, result.right];
                        }
                        else {
                            console.error(utils_1.errorsToArray(result.left));
                            throw new Error('Problem decoding signable withdrawal result');
                        }
                        return [3 /*break*/, 4];
                    case 3:
                        err_4 = _a.sent();
                        throw utils_1.formatError(err_4);
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    ImmutableXClient.prototype.transfer = function (from, to, token, quantizedAmount, nonce, expirationTimestamp, signature) {
        return __awaiter(this, void 0, void 0, function () {
            var assetID, data, res, result, err_5;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        assetID = imx_link_crypto_1.getAssetID(token).val;
                        data = JSON.stringify({
                            sender_stark_key: from.starkPublicKey,
                            sender_vault_id: parseInt(from.vaultId),
                            receiver_stark_key: to.starkPublicKey,
                            receiver_vault_id: parseInt(to.vaultId),
                            amount: parseInt(quantizedAmount),
                            asset_id: assetID,
                            expiration_timestamp: parseInt(expirationTimestamp),
                            nonce: parseInt(nonce),
                            stark_signature: signature,
                        });
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, axios_1.default.post(this.version + '/transfers', data, this.buildOptions())];
                    case 2:
                        res = _a.sent();
                        result = imx_link_types_1.ImmutableMethodResults.ImmutableTransferResultCodec.decode(res.data);
                        if (Either_1.isRight(result)) {
                            return [2 /*return*/, result.right];
                        }
                        else {
                            console.error(utils_1.errorsToArray(result.left));
                            throw new Error('Problem decoding transfer result');
                        }
                        return [3 /*break*/, 4];
                    case 3:
                        err_5 = _a.sent();
                        throw utils_1.formatError(err_5);
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    ImmutableXClient.prototype.getSignableTransfer = function (senderEtherKey, token, quantizedAmount, receiverEtherKey) {
        return __awaiter(this, void 0, void 0, function () {
            var data, res, result, err_6;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        data = JSON.stringify({
                            sender_ether_key: senderEtherKey,
                            token: {
                                type: token.type,
                                data: this.getTokenBody(token),
                            },
                            amount: parseInt(quantizedAmount),
                            receiver_ether_key: receiverEtherKey,
                        });
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, axios_1.default.post(this.version + '/signable-transfer-details', data, this.buildOptions())];
                    case 2:
                        res = _a.sent();
                        result = imx_link_types_1.ImmutableMethodResults.ImmutableGetSignableTransferResultCodec.decode(res.data);
                        if (Either_1.isRight(result)) {
                            return [2 /*return*/, result.right];
                        }
                        else {
                            console.error(utils_1.errorsToArray(result.left));
                            throw new Error('Problem decoding signable transfer result');
                        }
                        return [3 /*break*/, 4];
                    case 3:
                        err_6 = _a.sent();
                        throw utils_1.formatError(err_6);
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    ImmutableXClient.prototype.createOrder = function (starkPublicKey, sell, buy, nonce, expirationTimestamp, signature) {
        return __awaiter(this, void 0, void 0, function () {
            var data, res, result, err_7;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        data = JSON.stringify({
                            stark_key: starkPublicKey,
                            amount_sell: parseInt(sell.quantizedAmount),
                            asset_id_sell: imx_link_crypto_1.getAssetID(sell.token).val,
                            vault_id_sell: parseInt(sell.vaultId),
                            amount_buy: parseInt(buy.quantizedAmount),
                            asset_id_buy: imx_link_crypto_1.getAssetID(buy.token).val,
                            vault_id_buy: parseInt(buy.vaultId),
                            expiration_timestamp: parseInt(expirationTimestamp),
                            nonce: parseInt(nonce),
                            stark_signature: signature,
                        });
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, axios_1.default.post(this.version + '/orders', data, this.buildOptions())];
                    case 2:
                        res = _a.sent();
                        result = imx_link_types_1.ImmutableMethodResults.ImmutableCreateOrderResultCodec.decode(res.data);
                        if (Either_1.isRight(result)) {
                            return [2 /*return*/, result.right];
                        }
                        else {
                            console.error(utils_1.errorsToArray(result.left));
                            throw new Error('Problem decoding create order result');
                        }
                        return [3 /*break*/, 4];
                    case 3:
                        err_7 = _a.sent();
                        throw utils_1.formatError(err_7);
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    ImmutableXClient.prototype.getSignableOrder = function (etherKey, tokenSell, amountSell, tokenBuy, amountBuy) {
        return __awaiter(this, void 0, void 0, function () {
            var data, res, result, err_8;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        data = JSON.stringify({
                            ether_key: etherKey,
                            token_sell: {
                                type: tokenSell.type,
                                data: this.getTokenBody(tokenSell),
                            },
                            amount_sell: parseInt(amountSell),
                            token_buy: {
                                type: tokenBuy.type,
                                data: this.getTokenBody(tokenBuy),
                            },
                            amount_buy: parseInt(amountBuy),
                        });
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, axios_1.default.post(this.version + '/signable-order-details', data, this.buildOptions())];
                    case 2:
                        res = _a.sent();
                        result = imx_link_types_1.ImmutableMethodResults.ImmutableGetSignableOrderResultCodec.decode(res.data);
                        if (Either_1.isRight(result)) {
                            return [2 /*return*/, result.right];
                        }
                        else {
                            console.error(utils_1.errorsToArray(result.left));
                            throw new Error('Problem decoding signable order result');
                        }
                        return [3 /*break*/, 4];
                    case 3:
                        err_8 = _a.sent();
                        throw utils_1.formatError(err_8);
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    ImmutableXClient.prototype.createTrade = function (starkPublicKey, sell, buy, nonce, expirationTimestamp, signature, orderId) {
        return __awaiter(this, void 0, void 0, function () {
            var data, res, err_9;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        data = JSON.stringify({
                            stark_key: starkPublicKey,
                            amount_sell: parseInt(sell.quantizedAmount),
                            asset_id_sell: imx_link_crypto_1.getAssetID(sell.token).val,
                            vault_id_sell: parseInt(sell.vaultId),
                            amount_buy: parseInt(buy.quantizedAmount),
                            asset_id_buy: imx_link_crypto_1.getAssetID(buy.token).val,
                            vault_id_buy: parseInt(buy.vaultId),
                            expiration_timestamp: parseInt(expirationTimestamp),
                            nonce: parseInt(nonce),
                            stark_signature: signature,
                            order_id: parseInt(orderId),
                        });
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, axios_1.default.post(this.version + '/trades', data, this.buildOptions())];
                    case 2:
                        res = _a.sent();
                        return [2 /*return*/, res.data];
                    case 3:
                        err_9 = _a.sent();
                        throw utils_1.formatError(err_9);
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    ImmutableXClient.prototype.cancelOrder = function (starkPublicKey, orderId) {
        return __awaiter(this, void 0, void 0, function () {
            var nonce, _a, body, signature, data, res, err_10;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = parseInt;
                        return [4 /*yield*/, this.getLastAvailableNonce(starkPublicKey)];
                    case 1:
                        nonce = _a.apply(void 0, [(_b.sent()).Nonce]);
                        body = {
                            stark_key: starkPublicKey,
                            order_id: parseInt(orderId),
                            nonce: nonce,
                        };
                        return [4 /*yield*/, this.wallet.controller.signStark(body)];
                    case 2:
                        signature = _b.sent();
                        data = JSON.stringify(__assign(__assign({}, body), { stark_signature: signature }));
                        _b.label = 3;
                    case 3:
                        _b.trys.push([3, 5, , 6]);
                        return [4 /*yield*/, axios_1.default.post(this.version + '/cancel-order', data, this.buildOptions())];
                    case 4:
                        res = _b.sent();
                        return [2 /*return*/, res.data];
                    case 5:
                        err_10 = _b.sent();
                        throw utils_1.formatError(err_10);
                    case 6: return [2 /*return*/];
                }
            });
        });
    };
    ImmutableXClient.prototype.getBalancesF = function (params) {
        return this.get('balances/' + params.etherKey, imx_link_types_1.ImmutableMethodResults.ImmutableGetBalancesResultCodec.decode);
    };
    ImmutableXClient.prototype.getBalances = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.decodeForFunction(params, imx_link_types_1.ImmutableMethodParams.ImmutableGetBalancesParamsCodec.decode, this.getBalancesF)];
            });
        });
    };
    ImmutableXClient.prototype.getVaults = function (starkPublicKey) {
        return __awaiter(this, void 0, void 0, function () {
            var data, res, err_11;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        data = JSON.stringify({
                            stark_key: starkPublicKey,
                        });
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, axios_1.default.post(this.version + '/get-vaults', data, this.buildOptions())];
                    case 2:
                        res = _a.sent();
                        return [2 /*return*/, res.data];
                    case 3:
                        err_11 = _a.sent();
                        throw utils_1.formatError(err_11);
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    ImmutableXClient.prototype.getOrder = function (starkPublicKey, orderId) {
        return __awaiter(this, void 0, void 0, function () {
            var data, res, err_12;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        data = JSON.stringify({
                            order_id: parseInt(orderId),
                        });
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, axios_1.default.post(this.version + '/get-order', data, this.buildOptions())];
                    case 2:
                        res = _a.sent();
                        return [2 /*return*/, res.data];
                    case 3:
                        err_12 = _a.sent();
                        throw utils_1.formatError(err_12);
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    ImmutableXClient.prototype.getOrderList = function () {
        return __awaiter(this, void 0, void 0, function () {
            var res, result, err_13;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, axios_1.default.post(this.version + '/get-order-list', null, this.buildOptions())];
                    case 1:
                        res = _a.sent();
                        result = imx_link_types_1.ImmutableMethodResults.ImmutableGetOrderListResultCodec.decode(res.data);
                        if (Either_1.isRight(result)) {
                            return [2 /*return*/, result.right];
                        }
                        else {
                            console.error(utils_1.errorsToArray(result.left));
                            throw new Error('Problem decoding order list result');
                        }
                        return [3 /*break*/, 3];
                    case 2:
                        err_13 = _a.sent();
                        throw utils_1.formatError(err_13);
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    ImmutableXClient.prototype.getAssetListF = function (_a) {
        var owner = _a.owner, page_size = _a.page_size, next_page_token = _a.next_page_token;
        var url = query_string_1.default.stringifyUrl({
            url: "assets",
            query: {
                owner: owner,
                page_size: page_size,
                next_page_token: next_page_token,
            },
        });
        return this.get(url, imx_link_types_1.ImmutableMethodResults.ImmutableGetAssetListResultCodec.decode);
    };
    ImmutableXClient.prototype.getAssetList = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.decodeForFunction(params, imx_link_types_1.ImmutableMethodParams.ImmutableGetAssetListParamsCodec.decode, this.getAssetListF)];
            });
        });
    };
    ImmutableXClient.prototype.getAsset = function (_a) {
        var address = _a.address, id = _a.id;
        return __awaiter(this, void 0, void 0, function () {
            var res, result, err_14;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _b.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, axios_1.default.get(this.version + "/assets/" + address.toLowerCase() + "/" + id, this.buildOptions())];
                    case 1:
                        res = _b.sent();
                        result = imx_link_types_1.ImmutableMethodResults.ImmutableAssetCodec.decode(res.data);
                        if (Either_1.isRight(result)) {
                            return [2 /*return*/, result.right];
                        }
                        else {
                            console.error(utils_1.errorsToArray(result.left));
                            throw new Error('Problem decoding get asset result');
                        }
                        return [3 /*break*/, 3];
                    case 2:
                        err_14 = _b.sent();
                        throw utils_1.formatError(err_14);
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    ImmutableXClient.prototype.getDepositListF = function (query) {
        var url = query_string_1.default.stringifyUrl({
            url: 'deposits',
            query: query,
        });
        return this.get(url, imx_link_types_1.ImmutableMethodResults.ImmutableGetDepositListResultCodec.decode);
    };
    ImmutableXClient.prototype.getDepositList = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, utils_1.decodeForFunction(params, imx_link_types_1.ImmutableMethodParams.ImmutableGetDepositListParamsCodec.decode, this.getDepositListF)];
            });
        });
    };
    ImmutableXClient.prototype.getWithdrawalList = function (query) {
        return __awaiter(this, void 0, void 0, function () {
            var url, res, result, err_15;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        url = query_string_1.default.stringifyUrl({
                            url: this.version + "/withdrawals",
                            query: query,
                        });
                        return [4 /*yield*/, axios_1.default.get(url, this.buildOptions())];
                    case 1:
                        res = _a.sent();
                        result = imx_link_types_1.ImmutableMethodResults.ImmutableGetWithdrawalListResultCodec.decode(res.data);
                        if (Either_1.isRight(result)) {
                            return [2 /*return*/, result.right];
                        }
                        else {
                            console.error(utils_1.errorsToArray(result.left));
                            throw new Error('Problem decoding withdrawal list result');
                        }
                        return [3 /*break*/, 3];
                    case 2:
                        err_15 = _a.sent();
                        throw utils_1.formatError(err_15);
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    ImmutableXClient.prototype.getTransferList = function (query) {
        return __awaiter(this, void 0, void 0, function () {
            var url, res, result, err_16;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        url = query_string_1.default.stringifyUrl({
                            url: this.version + "/transfers",
                            query: query,
                        });
                        return [4 /*yield*/, axios_1.default.get(url, this.buildOptions())];
                    case 1:
                        res = _a.sent();
                        result = imx_link_types_1.ImmutableMethodResults.ImmutableGetTransferListResultCodec.decode(res.data);
                        if (Either_1.isRight(result)) {
                            return [2 /*return*/, result.right];
                        }
                        else {
                            console.error(utils_1.errorsToArray(result.left));
                            throw new Error('Problem decoding transfer list result');
                        }
                        return [3 /*break*/, 3];
                    case 2:
                        err_16 = _a.sent();
                        throw utils_1.formatError(err_16);
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    ImmutableXClient.prototype.getTradeList = function (query) {
        return __awaiter(this, void 0, void 0, function () {
            var url, res, result, err_17;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        url = query_string_1.default.stringifyUrl({
                            url: this.version + "/trades",
                            query: query,
                        });
                        return [4 /*yield*/, axios_1.default.get(url, this.buildOptions())];
                    case 1:
                        res = _a.sent();
                        result = imx_link_types_1.ImmutableMethodResults.ImmutableGetTradeListResultCodec.decode(res.data);
                        if (Either_1.isRight(result)) {
                            return [2 /*return*/, result.right];
                        }
                        else {
                            console.error(utils_1.errorsToArray(result.left));
                            throw new Error('Problem decoding trade list result');
                        }
                        return [3 /*break*/, 3];
                    case 2:
                        err_17 = _a.sent();
                        throw utils_1.formatError(err_17);
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    ImmutableXClient.prototype.getLastAvailableNonce = function (starkPublicKey) {
        return __awaiter(this, void 0, void 0, function () {
            var data, nonce, res, err_18;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        data = JSON.stringify({
                            stark_key: starkPublicKey,
                        });
                        nonce = 0;
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, axios_1.default.post(this.version + '/get-last-available-nonce', data, this.buildOptions())];
                    case 2:
                        res = _a.sent();
                        nonce = 'nonce' in res.data.result ? res.data.result.nonce : 0; // @x/core/api/interface.go
                        return [3 /*break*/, 4];
                    case 3:
                        err_18 = _a.sent();
                        throw utils_1.formatError(err_18);
                    case 4: return [2 /*return*/, { Nonce: String(nonce) }];
                }
            });
        });
    };
    ImmutableXClient.prototype.getTokenBody = function (token) {
        if (token.type.toUpperCase() === 'ETH') {
            var tokenI = token;
            return {
                quantum: parseInt(tokenI.data.quantum),
            };
        }
        else if (token.type.toUpperCase() === 'ERC20') {
            var tokenI = token;
            return {
                quantum: parseInt(tokenI.data.quantum),
                token_address: tokenI.data.tokenAddress,
            };
        }
        else if (token.type.toUpperCase() === 'ERC721') {
            var tokenI = token;
            return {
                token_id: tokenI.data.tokenId,
                token_address: tokenI.data.tokenAddress,
            };
        }
        else {
            throw new Error('Invalid token type');
        }
    };
    ImmutableXClient.prototype.decodeForFunction = function (params, decode, fn) {
        return __awaiter(this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = imx_link_types_1.valueOrThrow;
                        return [4 /*yield*/, pipeable_1.pipe(decode(params), E.mapLeft(utils_1.errorsToError), TE.fromEither, TE.chain(fn), TE.mapLeft(utils_1.formatError))()];
                    case 1: return [2 /*return*/, _a.apply(void 0, [_b.sent()])];
                }
            });
        });
    };
    ImmutableXClient.prototype.resolve = function (payload) {
        return __awaiter(this, void 0, void 0, function () {
            var id, method, params, report, _a, _b, _c, _d, depositCancelParams, _e, depositReclaimParams, _f, getSignableWithdrawalParams, _g, withdrawalParams, _h, transferParams, _j, getSignableTransferParams, _k, createOrderParams, _l, getSignableOrderParams, _m, createTradeParams, _o, cancelOrderParams, _p, _q, getVaultsParams, _r, getOrderParams, _s, _t, _u, getLastAvailableNonceParams, _v, error_1;
            return __generator(this, function (_w) {
                switch (_w.label) {
                    case 0:
                        id = payload.id, method = payload.method, params = payload.params;
                        _w.label = 1;
                    case 1:
                        _w.trys.push([1, 42, , 43]);
                        _a = method;
                        switch (_a) {
                            case 'imx_register': return [3 /*break*/, 2];
                            case 'imx_deposit': return [3 /*break*/, 4];
                            case 'imx_getSignableDeposit': return [3 /*break*/, 6];
                            case 'imx_depositCancel': return [3 /*break*/, 8];
                            case 'imx_depositReclaim': return [3 /*break*/, 10];
                            case 'imx_getSignableWithdrawal': return [3 /*break*/, 12];
                            case 'imx_withdrawal': return [3 /*break*/, 14];
                            case 'imx_transfer': return [3 /*break*/, 16];
                            case 'imx_getSignableTransfer': return [3 /*break*/, 18];
                            case 'imx_createOrder': return [3 /*break*/, 20];
                            case 'imx_getSignableOrder': return [3 /*break*/, 22];
                            case 'imx_createTrade': return [3 /*break*/, 24];
                            case 'imx_cancelOrder': return [3 /*break*/, 26];
                            case 'imx_getBalances': return [3 /*break*/, 28];
                            case 'imx_getVaults': return [3 /*break*/, 30];
                            case 'imx_getOrder': return [3 /*break*/, 32];
                            case 'imx_getOrderList': return [3 /*break*/, 34];
                            case 'imx_getAssetList': return [3 /*break*/, 36];
                            case 'imx_getLastAvailableNonce': return [3 /*break*/, 38];
                        }
                        return [3 /*break*/, 40];
                    case 2:
                        _b = {
                            id: id
                        };
                        return [4 /*yield*/, this.register(params)];
                    case 3: return [2 /*return*/, (_b.result = _w.sent(),
                            _b)];
                    case 4:
                        _c = {
                            id: id
                        };
                        return [4 /*yield*/, this.deposit(params)];
                    case 5: return [2 /*return*/, (_c.result = _w.sent(),
                            _c)];
                    case 6:
                        _d = {
                            id: id
                        };
                        return [4 /*yield*/, this.getSignableDeposit(params)];
                    case 7: return [2 /*return*/, (_d.result = _w.sent(),
                            _d)];
                    case 8:
                        report = io_ts_reporters_1.default.report(imx_link_types_1.ImmutableMethodParams.ImmutableDepositCancelParamsCodec.decode(params));
                        if (report.length != 0) {
                            throw new Error(report.toString());
                        }
                        depositCancelParams = params;
                        _e = {
                            id: id
                        };
                        return [4 /*yield*/, this.depositCancel(depositCancelParams.starkPublicKey, depositCancelParams.token, depositCancelParams.vaultId)];
                    case 9: return [2 /*return*/, (_e.result = _w.sent(),
                            _e)];
                    case 10:
                        report = io_ts_reporters_1.default.report(imx_link_types_1.ImmutableMethodParams.ImmutableDepositReclaimParamsCodec.decode(params));
                        if (report.length != 0) {
                            throw new Error(report.toString());
                        }
                        depositReclaimParams = params;
                        _f = {
                            id: id
                        };
                        return [4 /*yield*/, this.depositReclaim(depositReclaimParams.starkPublicKey, depositReclaimParams.token, depositReclaimParams.vaultId)];
                    case 11: return [2 /*return*/, (_f.result = _w.sent(),
                            _f)];
                    case 12:
                        report = io_ts_reporters_1.default.report(imx_link_types_1.ImmutableMethodParams.ImmutableGetSignableWithdrawalParamsCodec.decode(params));
                        if (report.length != 0) {
                            throw new Error(report.toString());
                        }
                        getSignableWithdrawalParams = params;
                        _g = {
                            id: id
                        };
                        return [4 /*yield*/, this.getSignableWithdrawal(getSignableWithdrawalParams.etherKey, getSignableWithdrawalParams.token, getSignableWithdrawalParams.quantizedAmount)];
                    case 13: return [2 /*return*/, (_g.result = _w.sent(),
                            _g)];
                    case 14:
                        report = io_ts_reporters_1.default.report(imx_link_types_1.ImmutableMethodParams.ImmutableWithdrawalParamsCodec.decode(params));
                        if (report.length != 0) {
                            throw new Error(report.toString());
                        }
                        withdrawalParams = params;
                        _h = {
                            id: id
                        };
                        return [4 /*yield*/, this.withdrawal(withdrawalParams.starkPublicKey, withdrawalParams.quantizedAmount, withdrawalParams.token, withdrawalParams.vaultId, withdrawalParams.nonce)];
                    case 15: return [2 /*return*/, (_h.result = _w.sent(),
                            _h)];
                    case 16:
                        report = io_ts_reporters_1.default.report(imx_link_types_1.ImmutableMethodParams.ImmutableTransferParamsCodec.decode(params));
                        if (report.length != 0) {
                            throw new Error(report.toString());
                        }
                        transferParams = params;
                        _j = {
                            id: id
                        };
                        return [4 /*yield*/, this.transfer(transferParams.from, transferParams.to, transferParams.token, transferParams.quantizedAmount, transferParams.nonce, transferParams.expirationTimestamp, transferParams.signature)];
                    case 17: return [2 /*return*/, (_j.result = _w.sent(),
                            _j)];
                    case 18:
                        report = io_ts_reporters_1.default.report(imx_link_types_1.ImmutableMethodParams.ImmutableGetSignableTransferParamsCodec.decode(params));
                        if (report.length != 0) {
                            throw new Error(report.toString());
                        }
                        getSignableTransferParams = params;
                        _k = {
                            id: id
                        };
                        return [4 /*yield*/, this.getSignableTransfer(getSignableTransferParams.senderEtherKey, getSignableTransferParams.token, getSignableTransferParams.quantizedAmount, getSignableTransferParams.receiverEtherKey)];
                    case 19: return [2 /*return*/, (_k.result = _w.sent(),
                            _k)];
                    case 20:
                        report = io_ts_reporters_1.default.report(imx_link_types_1.ImmutableMethodParams.ImmutableCreateOrderParamsCodec.decode(params));
                        if (report.length != 0) {
                            throw new Error(report.toString());
                        }
                        createOrderParams = params;
                        _l = {
                            id: id
                        };
                        return [4 /*yield*/, this.createOrder(createOrderParams.starkPublicKey, createOrderParams.sell, createOrderParams.buy, createOrderParams.nonce, createOrderParams.expirationTimestamp, createOrderParams.signature)];
                    case 21: return [2 /*return*/, (_l.result = _w.sent(),
                            _l)];
                    case 22:
                        report = io_ts_reporters_1.default.report(imx_link_types_1.ImmutableMethodParams.ImmutableGetSignableOrderParamsCodec.decode(params));
                        if (report.length != 0) {
                            throw new Error(report.toString());
                        }
                        getSignableOrderParams = params;
                        _m = {
                            id: id
                        };
                        return [4 /*yield*/, this.getSignableOrder(getSignableOrderParams.etherKey, getSignableOrderParams.tokenSell, getSignableOrderParams.amountSell, getSignableOrderParams.tokenBuy, getSignableOrderParams.amountBuy)];
                    case 23: return [2 /*return*/, (_m.result = _w.sent(),
                            _m)];
                    case 24:
                        report = io_ts_reporters_1.default.report(imx_link_types_1.ImmutableMethodParams.ImmutableCreateTradeParamsCodec.decode(params));
                        if (report.length != 0) {
                            throw new Error(report.toString());
                        }
                        createTradeParams = params;
                        _o = {
                            id: id
                        };
                        return [4 /*yield*/, this.createTrade(createTradeParams.starkPublicKey, createTradeParams.sell, createTradeParams.buy, createTradeParams.nonce, createTradeParams.expirationTimestamp, createTradeParams.signature, createTradeParams.orderId)];
                    case 25: return [2 /*return*/, (_o.result = _w.sent(),
                            _o)];
                    case 26:
                        report = io_ts_reporters_1.default.report(imx_link_types_1.ImmutableMethodParams.ImmutableCancelOrderParamsCodec.decode(params));
                        if (report.length != 0) {
                            throw new Error(report.toString());
                        }
                        cancelOrderParams = params;
                        _p = {
                            id: id
                        };
                        return [4 /*yield*/, this.cancelOrder(cancelOrderParams.starkPublicKey, cancelOrderParams.orderId)];
                    case 27: return [2 /*return*/, (_p.result = _w.sent(),
                            _p)];
                    case 28:
                        _q = {
                            id: id
                        };
                        return [4 /*yield*/, this.getBalances(params)];
                    case 29: return [2 /*return*/, (_q.result = _w.sent(),
                            _q)];
                    case 30:
                        report = io_ts_reporters_1.default.report(imx_link_types_1.ImmutableMethodParams.ImmutableGetVaultsParamsCodec.decode(params));
                        if (report.length != 0) {
                            throw new Error(report.toString());
                        }
                        getVaultsParams = params;
                        _r = {
                            id: id
                        };
                        return [4 /*yield*/, this.getVaults(getVaultsParams.starkPublicKey)];
                    case 31: return [2 /*return*/, (_r.result = _w.sent(),
                            _r)];
                    case 32:
                        report = io_ts_reporters_1.default.report(imx_link_types_1.ImmutableMethodParams.ImmutableGetOrderParamsCodec.decode(params));
                        if (report.length != 0) {
                            throw new Error(report.toString());
                        }
                        getOrderParams = params;
                        _s = {
                            id: id
                        };
                        return [4 /*yield*/, this.getOrder(getOrderParams.starkPublicKey, getOrderParams.orderId)];
                    case 33: return [2 /*return*/, (_s.result = _w.sent(),
                            _s)];
                    case 34:
                        _t = {
                            id: id
                        };
                        return [4 /*yield*/, this.getOrderList()];
                    case 35: return [2 /*return*/, (_t.result = _w.sent(),
                            _t)];
                    case 36:
                        _u = {
                            id: id
                        };
                        return [4 /*yield*/, this.getAssetList(params)];
                    case 37: return [2 /*return*/, (_u.result = _w.sent(),
                            _u)];
                    case 38:
                        report = io_ts_reporters_1.default.report(imx_link_types_1.ImmutableMethodParams.ImmutableGetLastAvailableNonceParamsCodec.decode(params));
                        if (report.length != 0) {
                            throw new Error(report.toString());
                        }
                        getLastAvailableNonceParams = params;
                        _v = {
                            id: id
                        };
                        return [4 /*yield*/, this.getLastAvailableNonce(getLastAvailableNonceParams.starkPublicKey)];
                    case 39: return [2 /*return*/, (_v.result = _w.sent(),
                            _v)];
                    case 40: throw new Error("Unknown ImmutableX REST-API Method: " + method);
                    case 41: return [3 /*break*/, 43];
                    case 42:
                        error_1 = _w.sent();
                        return [2 /*return*/, {
                                id: id,
                                error: {
                                    message: error_1.message,
                                },
                            }];
                    case 43: return [2 /*return*/];
                }
            });
        });
    };
    return ImmutableXClient;
}());
exports.ImmutableXClient = ImmutableXClient;
exports.default = ImmutableXClient;
//# sourceMappingURL=index.js.map