"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ImmutableXWallet = void 0;
var controller_1 = __importDefault(require("../controller"));
var bignumber_1 = require("@ethersproject/bignumber");
var experimental_1 = require("@ethersproject/experimental");
var imx_link_crypto_1 = require("@imtbl/imx-link-crypto");
var imx_link_types_1 = require("@imtbl/imx-link-types");
var auto_bind_1 = __importDefault(require("auto-bind"));
var E = __importStar(require("fp-ts/lib/Either"));
var O = __importStar(require("fp-ts/lib/Option"));
var pipeable_1 = require("fp-ts/lib/pipeable");
var TE = __importStar(require("fp-ts/lib/TaskEither"));
var io_ts_reporters_1 = __importDefault(require("io-ts-reporters"));
/**
 * Immutable X Wallet
 */
var ImmutableXWallet = /** @class */ (function () {
    function ImmutableXWallet(signer, accountMappingKey) {
        if (!signer.provider) {
            throw new Error('Signer is required to have a provider!');
        }
        this.signer = new experimental_1.NonceManager(signer);
        this.controller = new controller_1.default(this.signer, accountMappingKey);
        auto_bind_1.default(this);
    }
    ImmutableXWallet.prototype.incrementNonce = function () {
        if (this.signer instanceof experimental_1.NonceManager)
            this.signer.incrementTransactionCount();
    };
    ImmutableXWallet.prototype.getEthKey = function (contractAddress, starkPublicKey) {
        return __awaiter(this, void 0, void 0, function () {
            var exchangeContract;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        exchangeContract = this.controller.getExchangeContract(contractAddress);
                        return [4 /*yield*/, exchangeContract.getEthKey(starkPublicKey)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    ImmutableXWallet.prototype.getDepositBalance = function (contractAddress, starkPublicKey, token, vaultId) {
        return __awaiter(this, void 0, void 0, function () {
            var exchangeContract, assetId;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        exchangeContract = this.controller.getExchangeContract(contractAddress);
                        assetId = imx_link_crypto_1.getAssetID(token).toUint().val;
                        return [4 /*yield*/, exchangeContract.getQuantizedDepositBalance(starkPublicKey, assetId, vaultId)];
                    case 1: return [4 /*yield*/, (_a.sent()).toString()];
                    case 2: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    ImmutableXWallet.prototype.getWithdrawalBalance = function (contractAddress, starkPublicKey, token) {
        return __awaiter(this, void 0, void 0, function () {
            var exchangeContract, assetId;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        exchangeContract = this.controller.getExchangeContract(contractAddress);
                        assetId = imx_link_crypto_1.getAssetID(token).toUint().val;
                        return [4 /*yield*/, exchangeContract.getWithdrawalBalance(starkPublicKey, assetId)];
                    case 1: return [4 /*yield*/, (_a.sent()).toString()];
                    case 2: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    ImmutableXWallet.prototype.setupNFT = function (nftContractAddress, contractAddress, to, tokenId, tokenUri) {
        return __awaiter(this, void 0, void 0, function () {
            var unsignedTrx, mintTxHash, approveTxHash;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.controller.mintNFT(nftContractAddress, to, tokenId, tokenUri)];
                    case 1:
                        unsignedTrx = _a.sent();
                        return [4 /*yield*/, this.sendTransaction(unsignedTrx)];
                    case 2:
                        mintTxHash = _a.sent();
                        return [4 /*yield*/, this.controller.approveNFT({ nftContractAddress: nftContractAddress, contractAddress: contractAddress, tokenId: tokenId })];
                    case 3:
                        // Step 2: Approve Stark contract to deposit on behalf
                        unsignedTrx = _a.sent();
                        return [4 /*yield*/, this.sendTransaction(unsignedTrx)];
                    case 4:
                        approveTxHash = _a.sent();
                        return [2 /*return*/, "MintNFT: " + mintTxHash + ", ApproveNFT: " + approveTxHash];
                }
            });
        });
    };
    ImmutableXWallet.prototype.resolve = function (payload) {
        return __awaiter(this, void 0, void 0, function () {
            var id, method, params, report, _a, accountParams, accountResult, _b, transferParams, transferResult, _c, createOrderParams, createOrderResult, _d, registerParams, registerUnsignedTrx, registerTrx, registerResult, depositUnsignedTrx, depositTrx, depositResult, depositCancelParams, depositCancelUnsignedTrx, depositCancelTrx, depositCancelResult, depositReclaimParams, depositReclaimUnsignedTrx, depositReclaimTrx, depositReclaimResult, withdrawalParams, withdrawalUnsignedTrx, withdrawalTrx, withdrawalResult, fullWithdrawalParams, fullWithdrawalUnsignedTrx, fullWithdrawalTrx, fullWithdrawalResult, freezeParams, freezeUnsignedTrx, freezeTrx, freezeResult, verifyEscapeParams, verifyEscapeUnsignedTrx, verifyEscapeTrx, verifyEscapeResult, escapeParams, escapeUnsignedTrx, escapeTrx, escapeResult, getEthKeyParams, getEthKeyResult, _e, getDepositBalanceParams, getDepositBalanceResult, _f, getWithdrawalBalanceParams, getWithdrawalBalanceResult, _g, setupNFTParams, setupNFTResult, _h, mintNFTParams, mintNFTUnsignedTrx, mintNFTTrx, mintNFTResult, approveNFTUnsignedTrx, approveNFTTrx, approveNFTResult, error_1;
            return __generator(this, function (_j) {
                switch (_j.label) {
                    case 0:
                        id = payload.id, method = payload.method, params = payload.params;
                        _j.label = 1;
                    case 1:
                        _j.trys.push([1, 51, , 52]);
                        _a = method;
                        switch (_a) {
                            case 'stark_account': return [3 /*break*/, 2];
                            case 'stark_transfer': return [3 /*break*/, 4];
                            case 'stark_createOrder': return [3 /*break*/, 6];
                            case 'stark_register': return [3 /*break*/, 8];
                            case 'stark_deposit': return [3 /*break*/, 11];
                            case 'stark_depositCancel': return [3 /*break*/, 14];
                            case 'stark_depositReclaim': return [3 /*break*/, 17];
                            case 'stark_withdrawal': return [3 /*break*/, 20];
                            case 'stark_fullWithdrawal': return [3 /*break*/, 23];
                            case 'stark_freeze': return [3 /*break*/, 26];
                            case 'stark_verifyEscape': return [3 /*break*/, 29];
                            case 'stark_escape': return [3 /*break*/, 32];
                            case 'stark_getEthKey': return [3 /*break*/, 35];
                            case 'stark_getDepositBalance': return [3 /*break*/, 37];
                            case 'stark_getWithdrawalBalance': return [3 /*break*/, 39];
                            case 'stark_setupNFT': return [3 /*break*/, 41];
                            case 'stark_mintNFT': return [3 /*break*/, 43];
                            case 'stark_approveNFT': return [3 /*break*/, 46];
                        }
                        return [3 /*break*/, 49];
                    case 2:
                        report = io_ts_reporters_1.default.report(imx_link_types_1.StarkMethodParams.StarkAccountParamsCodec.decode(params));
                        if (report.length != 0) {
                            throw new Error(report.toString());
                        }
                        accountParams = params;
                        _b = {};
                        return [4 /*yield*/, this.controller.account(accountParams.layer, accountParams.application, accountParams.index)];
                    case 3:
                        accountResult = (_b.starkPublicKey = _j.sent(),
                            _b);
                        return [2 /*return*/, {
                                id: id,
                                result: accountResult,
                            }];
                    case 4:
                        report = io_ts_reporters_1.default.report(imx_link_types_1.StarkMethodParams.StarkTransferParamsCodec.decode(params));
                        if (report.length != 0) {
                            throw new Error(report.toString());
                        }
                        transferParams = params;
                        _c = {};
                        return [4 /*yield*/, this.controller.transfer(transferParams.from, transferParams.to, transferParams.token, transferParams.quantizedAmount, transferParams.nonce, transferParams.expirationTimestamp)];
                    case 5:
                        transferResult = (_c.starkSignature = _j.sent(),
                            _c);
                        return [2 /*return*/, {
                                id: id,
                                result: transferResult,
                            }];
                    case 6:
                        report = io_ts_reporters_1.default.report(imx_link_types_1.StarkMethodParams.StarkCreateOrderParamsCodec.decode(params));
                        if (report.length != 0) {
                            throw new Error(report.toString());
                        }
                        createOrderParams = params;
                        _d = {};
                        return [4 /*yield*/, this.controller.createOrder(createOrderParams.starkPublicKey, createOrderParams.sell, createOrderParams.buy, createOrderParams.nonce, createOrderParams.expirationTimestamp)];
                    case 7:
                        createOrderResult = (_d.starkSignature = _j.sent(),
                            _d);
                        return [2 /*return*/, {
                                id: id,
                                result: createOrderResult,
                            }];
                    case 8:
                        report = io_ts_reporters_1.default.report(imx_link_types_1.StarkMethodParams.StarkRegisterParamsCodec.decode(params));
                        if (report.length != 0) {
                            throw new Error(report.toString());
                        }
                        registerParams = params;
                        return [4 /*yield*/, this.controller.register(registerParams.contractAddress, registerParams.etherKey, registerParams.starkPublicKey, registerParams.operatorSignature)];
                    case 9:
                        registerUnsignedTrx = _j.sent();
                        return [4 /*yield*/, this.sendTransaction(registerUnsignedTrx)];
                    case 10:
                        registerTrx = _j.sent();
                        registerResult = {
                            txhash: registerTrx,
                        };
                        return [2 /*return*/, {
                                id: id,
                                result: registerResult,
                            }];
                    case 11: return [4 /*yield*/, this.controller.deposit(params)];
                    case 12:
                        depositUnsignedTrx = _j.sent();
                        return [4 /*yield*/, this.sendTransaction(depositUnsignedTrx)];
                    case 13:
                        depositTrx = _j.sent();
                        depositResult = {
                            txhash: depositTrx,
                        };
                        return [2 /*return*/, {
                                id: id,
                                result: depositResult,
                            }];
                    case 14:
                        report = io_ts_reporters_1.default.report(imx_link_types_1.StarkMethodParams.StarkDepositCancelParamsCodec.decode(params));
                        if (report.length != 0) {
                            throw new Error(report.toString());
                        }
                        depositCancelParams = params;
                        return [4 /*yield*/, this.controller.depositCancel(depositCancelParams.contractAddress, depositCancelParams.starkPublicKey, depositCancelParams.token, depositCancelParams.vaultId)];
                    case 15:
                        depositCancelUnsignedTrx = _j.sent();
                        return [4 /*yield*/, this.sendTransaction(depositCancelUnsignedTrx)];
                    case 16:
                        depositCancelTrx = _j.sent();
                        depositCancelResult = {
                            txhash: depositCancelTrx,
                        };
                        return [2 /*return*/, {
                                id: id,
                                result: depositCancelResult,
                            }];
                    case 17:
                        report = io_ts_reporters_1.default.report(imx_link_types_1.StarkMethodParams.StarkDepositReclaimParamsCodec.decode(params));
                        if (report.length != 0) {
                            throw new Error(report.toString());
                        }
                        depositReclaimParams = params;
                        return [4 /*yield*/, this.controller.depositReclaim(depositReclaimParams.contractAddress, depositReclaimParams.starkPublicKey, depositReclaimParams.token, depositReclaimParams.vaultId)];
                    case 18:
                        depositReclaimUnsignedTrx = _j.sent();
                        return [4 /*yield*/, this.sendTransaction(depositReclaimUnsignedTrx)];
                    case 19:
                        depositReclaimTrx = _j.sent();
                        depositReclaimResult = {
                            txhash: depositReclaimTrx,
                        };
                        return [2 /*return*/, {
                                id: id,
                                result: depositReclaimResult,
                            }];
                    case 20:
                        report = io_ts_reporters_1.default.report(imx_link_types_1.StarkMethodParams.StarkWithdrawalParamsCodec.decode(params));
                        if (report.length != 0) {
                            throw new Error(report.toString());
                        }
                        withdrawalParams = params;
                        return [4 /*yield*/, this.controller.withdrawal(withdrawalParams.contractAddress, withdrawalParams.starkPublicKey, withdrawalParams.token)];
                    case 21:
                        withdrawalUnsignedTrx = _j.sent();
                        return [4 /*yield*/, this.sendTransaction(withdrawalUnsignedTrx)];
                    case 22:
                        withdrawalTrx = _j.sent();
                        withdrawalResult = {
                            txhash: withdrawalTrx,
                        };
                        return [2 /*return*/, {
                                id: id,
                                result: withdrawalResult,
                            }];
                    case 23:
                        report = io_ts_reporters_1.default.report(imx_link_types_1.StarkMethodParams.StarkFullWithdrawalParamsCodec.decode(params));
                        if (report.length != 0) {
                            throw new Error(report.toString());
                        }
                        fullWithdrawalParams = params;
                        return [4 /*yield*/, this.controller.fullWithdrawal(fullWithdrawalParams.contractAddress, fullWithdrawalParams.starkPublicKey, fullWithdrawalParams.vaultId)];
                    case 24:
                        fullWithdrawalUnsignedTrx = _j.sent();
                        return [4 /*yield*/, this.sendTransaction(fullWithdrawalUnsignedTrx)];
                    case 25:
                        fullWithdrawalTrx = _j.sent();
                        fullWithdrawalResult = {
                            txhash: fullWithdrawalTrx,
                        };
                        return [2 /*return*/, {
                                id: id,
                                result: fullWithdrawalResult,
                            }];
                    case 26:
                        report = io_ts_reporters_1.default.report(imx_link_types_1.StarkMethodParams.StarkFreezeParamsCodec.decode(params));
                        if (report.length != 0) {
                            throw new Error(report.toString());
                        }
                        freezeParams = params;
                        return [4 /*yield*/, this.controller.freeze(freezeParams.contractAddress, freezeParams.starkPublicKey, freezeParams.vaultId)];
                    case 27:
                        freezeUnsignedTrx = _j.sent();
                        return [4 /*yield*/, this.sendTransaction(freezeUnsignedTrx)];
                    case 28:
                        freezeTrx = _j.sent();
                        freezeResult = {
                            txhash: freezeTrx,
                        };
                        return [2 /*return*/, {
                                id: id,
                                result: freezeResult,
                            }];
                    case 29:
                        report = io_ts_reporters_1.default.report(imx_link_types_1.StarkMethodParams.StarkVerifyEscapeParamsCodec.decode(params));
                        if (report.length != 0) {
                            throw new Error(report.toString());
                        }
                        verifyEscapeParams = params;
                        return [4 /*yield*/, this.controller.verifyEscape(verifyEscapeParams.contractAddress, verifyEscapeParams.starkPublicKey, verifyEscapeParams.proof)];
                    case 30:
                        verifyEscapeUnsignedTrx = _j.sent();
                        return [4 /*yield*/, this.sendTransaction(verifyEscapeUnsignedTrx)];
                    case 31:
                        verifyEscapeTrx = _j.sent();
                        verifyEscapeResult = {
                            txhash: verifyEscapeTrx,
                        };
                        return [2 /*return*/, {
                                id: id,
                                result: verifyEscapeResult,
                            }];
                    case 32:
                        report = io_ts_reporters_1.default.report(imx_link_types_1.StarkMethodParams.StarkEscapeParamsCodec.decode(params));
                        if (report.length != 0) {
                            throw new Error(report.toString());
                        }
                        escapeParams = params;
                        return [4 /*yield*/, this.controller.escape(escapeParams.contractAddress, escapeParams.starkPublicKey, escapeParams.vaultId, escapeParams.token, escapeParams.quantizedAmount)];
                    case 33:
                        escapeUnsignedTrx = _j.sent();
                        return [4 /*yield*/, this.sendTransaction(escapeUnsignedTrx)];
                    case 34:
                        escapeTrx = _j.sent();
                        escapeResult = {
                            txhash: escapeTrx,
                        };
                        return [2 /*return*/, {
                                id: id,
                                result: escapeResult,
                            }];
                    case 35:
                        report = io_ts_reporters_1.default.report(imx_link_types_1.StarkMethodParams.StarkGetEthKeyParamsCodec.decode(params));
                        if (report.length != 0) {
                            throw new Error(report.toString());
                        }
                        getEthKeyParams = params;
                        _e = {};
                        return [4 /*yield*/, this.getEthKey(getEthKeyParams.contractAddress, getEthKeyParams.etherKey)];
                    case 36:
                        getEthKeyResult = (_e.ethKey = _j.sent(),
                            _e);
                        return [2 /*return*/, {
                                id: id,
                                result: getEthKeyResult,
                            }];
                    case 37:
                        report = io_ts_reporters_1.default.report(imx_link_types_1.StarkMethodParams.StarkGetDepositBalanceParamsCodec.decode(params));
                        if (report.length != 0) {
                            throw new Error(report.toString());
                        }
                        getDepositBalanceParams = params;
                        _f = {};
                        return [4 /*yield*/, this.getDepositBalance(getDepositBalanceParams.contractAddress, getDepositBalanceParams.starkPublicKey, getDepositBalanceParams.token, getDepositBalanceParams.vaultId)];
                    case 38:
                        getDepositBalanceResult = (_f.balance = _j.sent(),
                            _f);
                        return [2 /*return*/, {
                                id: id,
                                result: getDepositBalanceResult,
                            }];
                    case 39:
                        report = io_ts_reporters_1.default.report(imx_link_types_1.StarkMethodParams.StarkGetWithdrawalBalanceParamsCodec.decode(params));
                        if (report.length != 0) {
                            throw new Error(report.toString());
                        }
                        getWithdrawalBalanceParams = params;
                        _g = {};
                        return [4 /*yield*/, this.getWithdrawalBalance(getWithdrawalBalanceParams.contractAddress, getWithdrawalBalanceParams.starkPublicKey, getWithdrawalBalanceParams.token)];
                    case 40:
                        getWithdrawalBalanceResult = (_g.balance = _j.sent(),
                            _g);
                        return [2 /*return*/, {
                                id: id,
                                result: getWithdrawalBalanceResult,
                            }];
                    case 41:
                        report = io_ts_reporters_1.default.report(imx_link_types_1.StarkMethodParams.StarkSetupNFTParamsCodec.decode(params));
                        if (report.length != 0) {
                            throw new Error(report.toString());
                        }
                        setupNFTParams = params;
                        _h = {};
                        return [4 /*yield*/, this.setupNFT(setupNFTParams.nftContractAddress, setupNFTParams.contractAddress, setupNFTParams.to, setupNFTParams.tokenId, setupNFTParams.tokenUri)];
                    case 42:
                        setupNFTResult = (_h.txhash = _j.sent(),
                            _h);
                        return [2 /*return*/, {
                                id: id,
                                result: setupNFTResult,
                            }];
                    case 43:
                        report = io_ts_reporters_1.default.report(imx_link_types_1.StarkMethodParams.StarkMintNFTParamsCodec.decode(params));
                        if (report.length != 0) {
                            throw new Error(report.toString());
                        }
                        mintNFTParams = params;
                        return [4 /*yield*/, this.controller.mintNFT(mintNFTParams.nftContractAddress, mintNFTParams.to, mintNFTParams.tokenId, mintNFTParams.tokenUri)];
                    case 44:
                        mintNFTUnsignedTrx = _j.sent();
                        return [4 /*yield*/, this.sendTransaction(mintNFTUnsignedTrx)];
                    case 45:
                        mintNFTTrx = _j.sent();
                        mintNFTResult = {
                            txhash: mintNFTTrx,
                        };
                        return [2 /*return*/, {
                                id: id,
                                result: mintNFTResult,
                            }];
                    case 46: return [4 /*yield*/, this.controller.approveNFT(params)];
                    case 47:
                        approveNFTUnsignedTrx = _j.sent();
                        return [4 /*yield*/, this.sendTransaction(approveNFTUnsignedTrx)];
                    case 48:
                        approveNFTTrx = _j.sent();
                        approveNFTResult = {
                            txhash: approveNFTTrx,
                        };
                        return [2 /*return*/, {
                                id: id,
                                result: approveNFTResult,
                            }];
                    case 49: throw new Error("Unknown StarkWare JSON-RPC Method: " + method);
                    case 50: return [3 /*break*/, 52];
                    case 51:
                        error_1 = _j.sent();
                        return [2 /*return*/, {
                                id: id,
                                error: {
                                    message: error_1.message,
                                },
                            }];
                    case 52: return [2 /*return*/];
                }
            });
        });
    };
    ImmutableXWallet.prototype.sendTransactionF = function (unsignedTrx, gasLimit, gasPrice) {
        var _this = this;
        var limit = pipeable_1.pipe(O.fromNullable(gasLimit), O.map(bignumber_1.BigNumber.from), O.getOrElse(function () { return bignumber_1.BigNumber.from(imx_link_crypto_1.DEFAULT_GAS_LIMIT.toString(10)); }));
        var price = pipeable_1.pipe(O.fromNullable(gasPrice), O.map(bignumber_1.BigNumber.from), O.getOrElse(function () { return bignumber_1.BigNumber.from(imx_link_crypto_1.DEFAULT_GAS_PRICE.toString(10)); }));
        return pipeable_1.pipe(TE.tryCatch(function () { return _this.signer.sendTransaction(__assign(__assign({}, unsignedTrx), { gasPrice: price, gasLimit: limit })); }, E.toError), TE.chain(function (r) {
            _this.incrementNonce();
            return TE.of(r.hash);
        }));
    };
    ImmutableXWallet.prototype.sendTransaction = function (unsignedTrx, gasLimit, gasPrice) {
        return __awaiter(this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = imx_link_types_1.valueOrThrow;
                        return [4 /*yield*/, this.sendTransactionF(unsignedTrx, gasLimit, gasPrice)()];
                    case 1: return [2 /*return*/, _a.apply(void 0, [_b.sent()])];
                }
            });
        });
    };
    return ImmutableXWallet;
}());
exports.ImmutableXWallet = ImmutableXWallet;
exports.default = ImmutableXWallet;
//# sourceMappingURL=index.js.map