"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.decodeForFunction = exports.eth8ToEth = exports.ethToEth8 = exports.switchCase = exports.errorsToArray = exports.errorsToError = exports.eth8Token = exports.getEthToken = exports.sleep = exports.generateWallet = exports.validateRPCResult = exports.formatError = exports.payloadId = void 0;
var bignumber_1 = require("@ethersproject/bignumber");
var providers_1 = require("@ethersproject/providers");
var units_1 = require("@ethersproject/units");
var wallet_1 = require("@ethersproject/wallet");
var imx_link_types_1 = require("@imtbl/imx-link-types");
var Array_1 = require("fp-ts-std/Array");
var function_1 = require("fp-ts/function");
var A = __importStar(require("fp-ts/lib/Array"));
var E = __importStar(require("fp-ts/lib/Either"));
var TE = __importStar(require("fp-ts/lib/TaskEither"));
var io_ts_reporters_1 = __importDefault(require("io-ts-reporters"));
var client_1 = require("../apps/imx/client");
var wallet_2 = require("../apps/wallet");
function payloadId() {
    var datePart = new Date().getTime() * Math.pow(10, 3);
    var extraPart = Math.floor(Math.random() * Math.pow(10, 3));
    var id = datePart + extraPart;
    return id;
}
exports.payloadId = payloadId;
function formatError(err) {
    if (err.response) {
        return new Error(JSON.stringify(err.response.data));
    }
    else if (err.request) {
        return new Error("Errno: " + err.errno + " Errcode: " + err.code);
    }
    else {
        return new Error(err.message);
    }
}
exports.formatError = formatError;
function validateRPCResult(data) {
    function printData() {
        console.dir(data, { depth: null });
    }
    if ('error' in data) {
        printData();
        throw new Error("RPC result contains error: " + data.error.message);
    }
    return data;
}
exports.validateRPCResult = validateRPCResult;
function generateWallet(env, index, privateKey, provider, signer) {
    return __awaiter(this, void 0, void 0, function () {
        var wallet, client, starkPublicKey, address;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!signer) {
                        signer = privateKey ? new wallet_1.Wallet(privateKey) : wallet_1.Wallet.createRandom();
                        if (provider) {
                            signer = signer.connect(provider);
                        }
                        else {
                            signer = signer.connect(new providers_1.EtherscanProvider('ropsten', env.etherscanApiKey));
                        }
                    }
                    wallet = new wallet_2.ImmutableXWallet(signer);
                    return [4 /*yield*/, wallet.controller.account(env.stark.layer, env.stark.application, index)];
                case 1:
                    _a.sent();
                    client = new client_1.ImmutableXClient('v1', env.imxHost, wallet);
                    starkPublicKey = wallet.controller.starkPublicKey;
                    if (!starkPublicKey) {
                        throw new Error('Problem generating stark public key');
                    }
                    return [4 /*yield*/, wallet.controller.getAddress()];
                case 2:
                    address = (_a.sent()).toLowerCase();
                    return [2 /*return*/, { wallet: wallet, client: client, starkPublicKey: starkPublicKey, address: address }];
            }
        });
    });
}
exports.generateWallet = generateWallet;
function sleep(time) {
    return new Promise(function (resolve) {
        setTimeout(resolve, time);
    });
}
exports.sleep = sleep;
exports.getEthToken = function (quantum) {
    return function_1.pipe(Math.pow(10, quantum), String, imx_link_types_1.PositiveIntegerString.decode, E.chain(function (quantum) {
        return E.right({
            type: imx_link_types_1.ETHTokenType.ETH,
            data: {
                quantum: quantum,
            },
        });
    }));
};
exports.eth8Token = function_1.pipe(exports.getEthToken(8), imx_link_types_1.valueOrThrow);
exports.errorsToError = function (errors) {
    return function_1.pipe(errors, errorsToArray, A.map(function (e) { return e.message; }), Array_1.join('. '), function (message) { return new Error(message); });
};
function errorsToArray(errors) {
    var result = io_ts_reporters_1.default.report(E.left(errors));
    if (result.length === 0) {
        return [];
    }
    else {
        return result.map(function (r) { return new Error(r); });
    }
}
exports.errorsToArray = errorsToArray;
exports.switchCase = function (value, cases, def) {
    return value in cases ? cases[value]() : def();
};
exports.ethToEth8 = function (amount) {
    return function_1.pipe(amount, units_1.parseEther, function (eth) { return eth.div(Math.pow(10, 8)); }, String, imx_link_types_1.PositiveIntegerString.decode);
};
exports.eth8ToEth = function (amount) {
    return function_1.pipe(amount, bignumber_1.BigNumber.from, function (eth) { return eth.mul(Math.pow(10, 8)); }, units_1.formatEther, imx_link_types_1.PositiveNumberString.decode);
};
function decodeForFunction(params, decode, fn) {
    return __awaiter(this, void 0, void 0, function () {
        var _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _a = imx_link_types_1.valueOrThrow;
                    return [4 /*yield*/, function_1.pipe(decode(params), E.mapLeft(exports.errorsToError), TE.fromEither, TE.chain(fn))()];
                case 1: return [2 /*return*/, _a.apply(void 0, [_b.sent()])];
            }
        });
    });
}
exports.decodeForFunction = decodeForFunction;
//# sourceMappingURL=utils.js.map